using System;
using System.IO;
using System.Security;
using System.Security.Permissions;

[assembly: FileIOPermission(SecurityAction.RequestMinimum, Read = "c:\\")]
namespace DemandPermissionDemo
{
	class DemandPermissionTest
	{
		static void CheckFileIOPermission()
		{
			FileIOPermission fiop = new FileIOPermission(PermissionState.Unrestricted);
			fiop.Demand();
		}

		static void Main(string[] args)
		{
			try 
			{
				CheckFileIOPermission();
				Console.WriteLine("Unrestricted FileIOPermission granted.");

				StreamWriter textFile = File.CreateText("c:\\FileAccessDemo.txt");
				textFile.WriteLine("This file is created by File Access Demo!");
				textFile.Close();

				Console.WriteLine("Successfully created a file.");
			} 
			catch (SecurityException se) 
			{
				Console.WriteLine("Unrestricted FileIOPermission not granted: " + se);
			}
			Console.ReadLine();
		}
	}
}
