using System;
using System.IO;
using System.Security.Principal;

namespace GenericRoleDemo
{
	class GenericRoleTest
	{
		static void PerformAuthentication() 
		{
			Console.Write("Enter the admin password: ");
			String password = Console.ReadLine();
			if (password.Equals("secret")) 
			{
				GenericIdentity identity = new GenericIdentity("admin");
				string[] roles = new string[]{"admins", "users"};
				GenericPrincipal principal = new GenericPrincipal(identity, roles);
				System.Threading.Thread.CurrentPrincipal = principal;
				Console.WriteLine("You are now authenticated as admin.");
			} 
			else 
			{
				Console.WriteLine("Authentication failed!");
			}
		}

		static void CreateFile()
		{
			IPrincipal currentPrincipal = System.Threading.Thread.CurrentPrincipal;

			if (currentPrincipal.IsInRole("admins"))
			{
				// Create the file
				StreamWriter textFile = File.CreateText("c:\\FileAccessDemo.txt");
				textFile.WriteLine("This file is created by File Access Demo!");
				textFile.Close();
				Console.WriteLine("File created.");
			} 
			else 
			{
				Console.WriteLine("Admin priviledges are required!");
			}
		}

		static void Main(string[] args)
		{
			PerformAuthentication();
			CreateFile();
			Console.ReadLine();
		}
	}
}
